commit:     fd2fce14c2b61e2baac6feff9be545c4940f09f4
Author:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
AuthorDate: Fri Feb  2 11:19:23 2018 +0000
Commit:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
CommitDate: Fri Feb  2 11:19:23 2018 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=fd2fce14

net-misc/dhcp: Bump to version 4.4.0

Package-Manager: Portage-2.3.23, Repoman-2.3.6

 net-misc/dhcp/Manifest                             |   1 +
 net-misc/dhcp/dhcp-4.4.0.ebuild                    | 264 +++++++++++++++++++++
 .../dhcp/files/dhcp-4.4.0-always-accept-4.patch    |  29 +++
 net-misc/dhcp/files/dhcp-4.4.0-bind-disable.patch  |  22 ++
 4 files changed, 316 insertions(+)

diff --git a/net-misc/dhcp/Manifest b/net-misc/dhcp/Manifest
index 7f8bf667d55..a0c93eb7fa5 100644
--- a/net-misc/dhcp/Manifest
+++ b/net-misc/dhcp/Manifest
@@ -1,3 +1,4 @@
 DIST dhcp-4.3.4.tar.gz 9302513 BLAKE2B 
eb7fb7d7d46d5a706b4f22b4add98619709f7ac1ecf8244564f043fd56adb6e2f54a0e01b573abcd7e054a82f74279c8134802380ee2d02c1cab1118d48a4965
 SHA512 
411c3f0e1effedb2a95f00539d13164530a56b50830008eb78906b3c8bf4070c331cf54a431770aed5d1b6ba214840446964210060674f746781cc97842ad706
 DIST dhcp-4.3.5.tar.gz 10075147 BLAKE2B 
ffce896cfafe17a412030d0a1cb4a92323be175ecbb35061fe0538ed13a9f91d604daed89b5f282c92ef161944e9f18557545d95c9fbbd29e1f6a31485ef3b11
 SHA512 
aba0e1d361eb9e7ed33fc48c0b0b9288057af9ec51775e40e27feb9ababc182506706fcf39079236ce36b0f7ded391e107474dc29de2e60ed45d37753505e1f0
 DIST dhcp-4.3.6.tar.gz 10182593 BLAKE2B 
2b6324c63446a5cbded9a7cdd4455b6c880aabd282dfd19d44fe2fafe684a991b4afa87ec04ee3fc131437c8efdddbe2777d70586c2e8b2b4319e786325dc398
 SHA512 
de4962dc2aa174df17a3a1456719a777a42d238c3d6ad1771ccc460fa70c9e9cefcce52c7437f7acde61b9c3a2e84e9d49fd2dc33c7e9243053ceed5b247be03
+DIST dhcp-4.4.0.tar.gz 11158069 BLAKE2B 
c554e15f549bdf6342bfa4337ab54f2a259a1c212700a69b56d795b1c91230759e254b050087ad09cf065d9dcc380e6110a95d63c3d2ba982c567dd381889d3e
 SHA512 
0dcddfe803db0cea49204f71c9fbc3b1a55496acc83e344d9147893410bbb5f96874ff6457037ee9f759d701cea4bab98dc51ad5d7b23926254e25e5e421eabd

diff --git a/net-misc/dhcp/dhcp-4.4.0.ebuild b/net-misc/dhcp/dhcp-4.4.0.ebuild
new file mode 100644
index 00000000000..ff83c6a59ab
--- /dev/null
+++ b/net-misc/dhcp/dhcp-4.4.0.ebuild
@@ -0,0 +1,264 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit systemd toolchain-funcs user
+
+MY_PV="${PV//_alpha/a}"
+MY_PV="${MY_PV//_beta/b}"
+MY_PV="${MY_PV//_rc/rc}"
+MY_PV="${MY_PV//_p/-P}"
+MY_P="${PN}-${MY_PV}"
+DESCRIPTION="ISC Dynamic Host Configuration Protocol (DHCP) client/server"
+HOMEPAGE="http://www.isc.org/products/DHCP";
+SRC_URI="ftp://ftp.isc.org/isc/dhcp/${MY_P}.tar.gz
+       ftp://ftp.isc.org/isc/dhcp/${MY_PV}/${MY_P}.tar.gz";
+
+LICENSE="ISC BSD SSLeay GPL-2" # GPL-2 only for init script
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 
~sh ~sparc ~x86 ~amd64-fbsd ~x86-fbsd"
+IUSE="+client ipv6 kernel_linux ldap libressl selinux +server ssl vim-syntax"
+
+DEPEND="
+       client? (
+               kernel_linux? (
+                       ipv6? ( sys-apps/iproute2 )
+                       sys-apps/net-tools
+               )
+       )
+       ldap? (
+               net-nds/openldap
+               ssl? (
+                       !libressl? ( dev-libs/openssl:0 )
+                       libressl? ( dev-libs/libressl )
+               )
+       )"
+RDEPEND="${DEPEND}
+       selinux? ( sec-policy/selinux-dhcp )
+       vim-syntax? ( app-vim/dhcpd-syntax )"
+
+S="${WORKDIR}/${MY_P}"
+
+src_unpack() {
+       unpack ${A}
+       # handle local bind hell
+       cd "${S}"/bind
+       unpack ./bind.tar.gz
+}
+
+PATCHES=(
+       # Gentoo patches - these will probably never be accepted upstream
+       # Fix some permission issues
+       "${FILESDIR}/${PN}-3.0-fix-perms.patch"
+
+       # Enable dhclient to equery NTP servers
+       "${FILESDIR}/${PN}-4.3.6-dhclient-ntp.patch"
+       "${FILESDIR}/${PN}-4.3.6-dhclient-resolvconf.patch"
+
+       # Enable dhclient to get extra configuration from stdin
+       "${FILESDIR}/${PN}-4.2.2-dhclient-stdin-conf.patch"
+       "${FILESDIR}/${PN}-4.3.6-nogateway.patch" #265531
+       "${FILESDIR}/${PN}-4.3.6-quieter-ping.patch" #296921
+       "${FILESDIR}/${PN}-4.4.0-always-accept-4.patch" #437108
+       "${FILESDIR}/${PN}-4.3.6-iproute2-path.patch" #480636
+       "${FILESDIR}/${PN}-4.2.5-bindtodevice-inet6.patch" #471142
+       "${FILESDIR}/${PN}-4.3.3-ldap-ipv6-client-id.patch" #559832
+)
+
+src_prepare() {
+       default
+
+       # Brand the version with Gentoo
+       sed -i \
+               -e "/VERSION=/s:'$: Gentoo-${PR}':" \
+               configure || die
+
+       # Change the hook script locations of the scripts
+       sed -i \
+               -e 's,/etc/dhclient-exit-hooks,/etc/dhcp/dhclient-exit-hooks,g' 
\
+               -e 
's,/etc/dhclient-enter-hooks,/etc/dhcp/dhclient-enter-hooks,g' \
+               client/scripts/* || die
+
+       # No need for the linux script to force bash #158540
+       sed -i -e 's,#!/bin/bash,#!/bin/sh,' client/scripts/linux || die
+
+       # Quiet the freebsd logger a little
+       sed -i -e '/LOGGER=/ s/-s -p user.notice //g' client/scripts/freebsd || 
die
+
+       # Remove these options from the sample config
+       sed -i -r \
+               -e "/(script|host-name|domain-name) /d" \
+               client/dhclient.conf.example || die
+
+       if use client && ! use server ; then
+               sed -i -r \
+                       -e '/^SUBDIRS/s:\<(dhcpctl|relay|server)\>::g' \
+                       Makefile.in || die
+       elif ! use client && use server ; then
+               sed -i -r \
+                       -e '/^SUBDIRS/s:\<client\>::' \
+                       Makefile.in || die
+       fi
+
+       # Only install different man pages if we don't have en
+       if [[ " ${LINGUAS} " != *" en "* ]]; then
+               # Install Japanese man pages
+               if [[ " ${LINGUAS} " == *" ja "* && -d doc/ja_JP.eucJP ]]; then
+                       einfo "Installing Japanese documention"
+                       cp doc/ja_JP.eucJP/dhclient* client || die
+                       cp doc/ja_JP.eucJP/dhcp* common || die
+               fi
+       fi
+       # Now remove the non-english docs so there are no errors later
+       rm -r doc/ja_JP.eucJP || die
+
+       # make the bind build work
+       binddir="${S}/bind"
+       cd "${binddir}" || die
+       cat <<-EOF > bindvar.tmp
+       binddir=${binddir}
+       GMAKE=${MAKE:-gmake}
+       EOF
+       eapply -p2 "${FILESDIR}"/${PN}-4.4.0-bind-disable.patch
+       # Only use the relevant subdirs now that ISC
+       #removed the lib/export structure in bind.
+       sed '/^SUBDIRS/s@=.*$@= isc dns isccfg irs samples@' \
+               -i bind-*/lib/Makefile.in || die
+}
+
+src_configure() {
+       # bind defaults to stupid `/usr/bin/ar`
+       tc-export AR BUILD_CC
+       export ac_cv_path_AR=${AR}
+
+       # this is tested for by the bind build system, and can cause trouble
+       # when cross-building; since dhcp itself doesn't make use of libcap,
+       # simply disable it.
+       export ac_cv_lib_cap_cap_set_proc=no
+
+       # Use FHS sane paths ... some of these have configure options,
+       # but not all, so just do it all here.
+       local e="/etc/dhcp" r="/var/run/dhcp" l="/var/lib/dhcp"
+       cat <<-EOF >> includes/site.h
+       #define _PATH_DHCPD_CONF     "${e}/dhcpd.conf"
+       #define _PATH_DHCLIENT_CONF  "${e}/dhclient.conf"
+       #define _PATH_DHCPD_DB       "${l}/dhcpd.leases"
+       #define _PATH_DHCPD6_DB      "${l}/dhcpd6.leases"
+       #define _PATH_DHCLIENT_DB    "${l}/dhclient.leases"
+       #define _PATH_DHCLIENT6_DB   "${l}/dhclient6.leases"
+       #define _PATH_DHCPD_PID      "${r}/dhcpd.pid"
+       #define _PATH_DHCPD6_PID     "${r}/dhcpd6.pid"
+       #define _PATH_DHCLIENT_PID   "${r}/dhcpclient.pid"
+       #define _PATH_DHCLIENT6_PID  "${r}/dhcpclient6.pid"
+       #define _PATH_DHCRELAY_PID   "${r}/dhcrelay.pid"
+       #define _PATH_DHCRELAY6_PID  "${r}/dhcrelay6.pid"
+       EOF
+
+       local myeconfargs=(
+               --enable-paranoia
+               --enable-early-chroot
+               --sysconfdir=${e}
+               $(use_enable ipv6 dhcpv6)
+               $(use_with ldap)
+               $(use ldap && use_with ssl ldapcrypto || echo 
--without-ldapcrypto)
+       )
+       econf "${myeconfargs[@]}"
+
+       # configure local bind cruft.  symtable option requires
+       # perl and we don't want to require that #383837.
+       cd bind/bind-*/ || die
+       eval econf \
+               $(for el in $(awk '/^bindconfig/,/^$/ {print}' ../Makefile.in) 
; do if [[ ${el} =~ ^-- ]] ; then printf ' %s' ${el}; fi; done | sed 
's,@\([[:alpha:]]\+\)dir@,${binddir}/\1,g') \
+               --disable-symtable \
+               --without-make-clean
+}
+
+src_compile() {
+       # build local bind cruft first
+       emake -C bind/bind-*/lib install
+       # then build standard dhcp code
+       emake AR="$(tc-getAR)"
+}
+
+src_install() {
+       default
+
+       dodoc README RELNOTES doc/{api+protocol,IANA-arp-parameters}
+       docinto html
+       dodoc doc/References.html
+
+       if [[ -e client/dhclient ]] ; then
+               # move the client to /
+               dodir /sbin
+               mv "${D}"/usr/sbin/dhclient "${D}"/sbin/ || die
+
+               exeinto /sbin
+               if use kernel_linux ; then
+                       newexe "${S}"/client/scripts/linux dhclient-script
+               else
+                       newexe "${S}"/client/scripts/freebsd dhclient-script
+               fi
+       fi
+
+       if [[ -e server/dhcpd ]] ; then
+               if use ldap ; then
+                       insinto /etc/openldap/schema
+                       doins contrib/ldap/dhcp.*
+                       dosbin contrib/ldap/dhcpd-conf-to-ldap
+               fi
+
+               newinitd "${FILESDIR}"/dhcpd.init5 dhcpd
+               newconfd "${FILESDIR}"/dhcpd.conf2 dhcpd
+               newinitd "${FILESDIR}"/dhcrelay.init3 dhcrelay
+               newconfd "${FILESDIR}"/dhcrelay.conf dhcrelay
+               newinitd "${FILESDIR}"/dhcrelay.init3 dhcrelay6
+               newconfd "${FILESDIR}"/dhcrelay6.conf dhcrelay6
+
+               systemd_newtmpfilesd "${FILESDIR}"/dhcpd.tmpfiles dhcpd.conf
+               systemd_dounit "${FILESDIR}"/dhcpd4.service
+               systemd_dounit "${FILESDIR}"/dhcpd6.service
+               systemd_dounit "${FILESDIR}"/dhcrelay4.service
+               systemd_dounit "${FILESDIR}"/dhcrelay6.service
+               systemd_install_serviced "${FILESDIR}"/dhcrelay4.service.conf
+               systemd_install_serviced "${FILESDIR}"/dhcrelay6.service.conf
+
+               sed -i "s:#@slapd@:$(usex ldap slapd ''):" "${ED}"/etc/init.d/* 
|| die #442560
+       fi
+
+       # the default config files aren't terribly useful #384087
+       local f
+       for f in "${ED}"/etc/dhcp/*.conf.example ; do
+               mv "${f}" "${f%.example}" || die
+       done
+       sed -i '/^[^#]/s:^:#:' "${ED}"/etc/dhcp/*.conf || die
+}
+
+pkg_preinst() {
+       enewgroup dhcp
+       enewuser dhcp -1 -1 /var/lib/dhcp dhcp
+
+       # Keep the user files over the sample ones.  The
+       # hashing is to ignore the crappy defaults #384087.
+       local f h
+       for f in dhclient:da7c8496a96452190aecf9afceef4510 
dhcpd:10979e7b71134bd7f04d2a60bd58f070 ; do
+               h=${f#*:}
+               f="/etc/dhcp/${f%:*}.conf"
+               if [ -e "${EROOT}"${f} ] ; then
+                       case $(md5sum "${EROOT}"${f}) in
+                               ${h}*) ;;
+                               *) cp -p "${EROOT}"${f} "${ED}"${f};;
+                       esac
+               fi
+       done
+}
+
+pkg_postinst() {
+       if [[ -e "${ROOT}"/etc/init.d/dhcp ]] ; then
+               ewarn
+               ewarn "WARNING: The dhcp init script has been renamed to dhcpd"
+               ewarn "/etc/init.d/dhcp and /etc/conf.d/dhcp need to be removed 
and"
+               ewarn "and dhcp should be removed from the default runlevel"
+               ewarn
+       fi
+}

diff --git a/net-misc/dhcp/files/dhcp-4.4.0-always-accept-4.patch 
b/net-misc/dhcp/files/dhcp-4.4.0-always-accept-4.patch
new file mode 100644
index 00000000000..bbb25eb194b
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.4.0-always-accept-4.patch
@@ -0,0 +1,29 @@
+https://bugs.gentoo.org/437108
+
+Always accept the -4 option even if we don't have IPv6 support enabled.
+The relay code does this already.
+
+--- dhcp-4.4.0/client/dhclient.c
++++ dhcp-4.4.0/client/dhclient.c
+@@ -353,8 +353,8 @@
+               if (!strcmp(argv[i], "-r")) {
+                       release_mode = 1;
+                       /* no_daemon = 1; */
+-#ifdef DHCPv6
+               } else if (!strcmp(argv[i], "-4")) {
++#ifdef DHCPv6
+                       if (local_family_set && local_family != AF_INET)
+                               log_fatal("Client can only do v4 or v6, not "
+                                         "both.");
+--- dhcp-4.4.0/server/dhcpd.c
++++ dhcp-4.4.0/server/dhcpd.c
+@@ -495,8 +495,8 @@
+               } else if (!strcmp (argv [i], "-q")) {
+                       quiet = 1;
+                       quiet_interface_discovery = 1;
+-#ifdef DHCPv6
+               } else if (!strcmp(argv[i], "-4")) {
++#ifdef DHCPv6
+                       if (local_family_set && (local_family != AF_INET)) {
+                               log_fatal("Server cannot run in both IPv4 and "
+                                         "IPv6 mode at the same time.");

diff --git a/net-misc/dhcp/files/dhcp-4.4.0-bind-disable.patch 
b/net-misc/dhcp/files/dhcp-4.4.0-bind-disable.patch
new file mode 100644
index 00000000000..b74255ca4e9
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.4.0-bind-disable.patch
@@ -0,0 +1,22 @@
+--- dhcp-4.4.0/bind/Makefile.in
++++ dhcp-4.4.0/bind/Makefile.in
+@@ -37,6 +37,7 @@
+ @BIND_ATF_TRUE@all: bind1 atf bind2
+ 
+ bind1:
++disable:
+ # Extract the source from the tarball, if it hasn't been already.
+       @if test -d ${bindsrcdir} ; then                  \
+               echo ${bindsrcdir} already unpacked... ;  \
+@@ -60,6 +61,7 @@
+       fi
+ 
+ atf:
++disable:
+ # Build and copy the ATF support if not yet installed.
+       @if test -d ./atf ; then                      \
+               echo ATF support already installed ;  \
+--- dhcp-4.4.0/bind/test
++++ dhcp-4.4.0/bind/test
+@@ -0,0 +1 @@
++--disable-kqueue --disable-epoll --disable-devpoll --without-openssl 
--without-libxml2 --enable-exportlib --with-gssapi=no --enable-threads=no 
@BINDCONFIG@ --includedir=${binddir}/include --libdir=${binddir}/lib

Reply via email to